#include<bits/stdc++.h>
using namespace std;

int n,a,b,dof[100005],q;
vector<int> t[100005];

int fs(int h){
    int res=0;
    for(int j=0;j<t[h].size();j++){
        res+=fs(t[h][j]);
    }
    res++;
    return res;
}

void pech(){
    cout<<endl;
    for(int i=1;i<n;i++){
        cout<<i<<" -> ";
        for(int j=0;j<t[i].size();j++){
            cout<<t[i][j]<<" ";
        }
        cout<<endl;
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;
    for(int i=0;i<n-1;i++){
        cin>>a>>b;
        t[a].push_back(b);
    }
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>dof[i];
    }
    for(int i=0;i<q;i++){
        cout<<fs(dof[i])-1<<" ";
    }
    cout<<endl;
    pech();

    return 0;
}

